<style src="./Deal.scss" lang="scss" scoped></style>
<script src="./Deal.js"></script>

với <template>
  <div class="m-content">
    <div
      v-if="!isLoader"
      class="m-loader m-loader--brand m-loader--lg"
      style="width: 30px; height: 30px; display: inline-block;"
    ></div>

    <div style="display: inline-block; width: 100%" v-else class="nt-page position-relative">
      <!--<div class="s-list--filter">
                <div style="width: 320px; float:left; margin-right: 20px">
                    <filter-deal>
                    </filter-deal>
                </div>
      </div>-->

      <!--<div class="s-list--total-price">-->
      <!--<ul class="list-unstyled">-->
      <!--<li>-->
      <!--<span class="nt-label">Tổng giá trị <template v-if="!isSearch && !isFilter">tất cả</template> giao dịch <template v-if="isSearch || isFilter">tìm thấy</template>: </span>-->
      <!--<span>{{ parseFloat(totalPriceAllDeal) | formatNumberPrice }}</span>-->
      <!--</li>-->
      <!--</ul>-->
      <!--</div>-->
      <div
        class="s-list--filter nt-list-filter d-flex align-items-baseline justify-content-between"
      >
        <filter-deal
          :filter_data="getDealFilters"
          :full_attributes="allAttributes"
          :total_items="pagination.total_item"
          :filter_attributes="filterAttributes"
          :cache_attributes_filter="cacheForFilterAttributes"
          :filter_type="3"
          @is_response_success="isResponseSuccess"
          @show_filter="filterShow"
          @show_is_all_data="filterAllData"
          @start_filter="startFilter"
          @show_filter_id="showFilterGetId"
          @cancel_filter="cancelFilter"
          @minimizeFilter="isMinimizeFilter = $event"
        ></filter-deal>
        <div class="d-flex display-type">
          <div
            class="display-type_view d-flex align-items-center"
            :class="{ 'active': displayType === displayOptions.table }"
            @click="displayType = displayOptions.table"
          >
            <i class="icon icon-table-2"></i>
            <span class="d-none d-md-inline">Dạng bảng</span>
          </div>
          <div
            class="display-type_view d-flex align-items-center"
            :class="{ 'active': displayType === displayOptions.pipeline }"
            @click="displayType = displayOptions.pipeline"
          >
            <i class="icon icon-pipeline"></i>
            <span class="d-none d-md-inline">Dạng pipeline</span>
          </div>
        </div>
      </div>
      <div :class="{ 'deal-display': showFilter, 'filter-minimize': isMinimizeFilter }">
        <div
          v-if="displayType === displayOptions.table"
          class="nt-page-content m-portlet m-portlet--mobile mb-0 position-relative"
        >
          <div class="m-portlet__body">
            <div
              class="m-portlet__body-head"
              v-if="showFilter || isSearch || pagination.total_item > 0"
            >
              <div class="m-portlet__body-head-top">
                <div class="m-portlet__body-head-top-left">
                  <div class="s--list-action">
                    <div
                      aria-expanded="true"
                      m-dropdown-toggle="click"
                      class="m-dropdown m-dropdown--inline m-dropdown--arrow m-dropdown--align-left m-dropdown--align-push nt-button-dropdown"
                    >
                      <a
                        class="m-portlet__nav-link m-dropdown__toggle nt-button nt-button-primary nt-button-top"
                        style="border-radius: 4px"
                      >
                        <i class="icon icon-settings"></i>&nbsp;Tác vụ
                      </a>
                      <div class="m-dropdown__wrapper" style="z-index: 101;">
                        <span
                          class="m-dropdown__arrow m-dropdown__arrow--left m-dropdown__arrow--adjust"
                          style="right: auto; left: 60.5px;"
                        ></span>
                        <div class="m-dropdown__inner">
                          <div class="m-dropdown__body">
                            <div class="m-dropdown__content">
                              <ul class="m-nav">
                                <li class="m-nav__item">
                                  <a
                                    class="m-nav__link"
                                    href="javascript:;"
                                    @click.prevent="exportDeal(1)"
                                    v-if="accessible( userCheckAddOn, 'deal', PERMISSION_EXPORT_DEAL_BASIC, userCurrentPermissions)"
                                  >
                                    <i class="m-nav__link-icon icon icon-export"></i>
                                    <span class="m-nav__link-text">Export giao dịch rút gọn</span>
                                  </a>
                                  <a
                                    class="m-nav__link nt-disabled-link-permisson"
                                    href="javascript:;"
                                    v-else
                                    data-toggle="m-tooltip"
                                    :data-original-title="titleNotPermisson"
                                    data-html="true"
                                  >
                                    <i class="m-nav__link-icon icon icon-export"></i>
                                    <span class="m-nav__link-text">Export giao dịch rút gọn</span>
                                  </a>
                                </li>
                                <li class="m-nav__item">
                                  <a
                                    class="m-nav__link"
                                    href="javascript:;"
                                    @click.prevent="exportDeal(2)"
                                    v-if="accessible( userCheckAddOn, 'deal', PERMISSION_EXPORT_DEAL_PRODUCT, userCurrentPermissions)"
                                  >
                                    <i class="m-nav__link-icon icon icon-export"></i>
                                    <span class="m-nav__link-text">Export giao dịch có sản phẩm</span>
                                  </a>
                                  <a
                                    class="m-nav__link nt-disabled-link-permisson"
                                    href="javascript:;"
                                    v-else
                                    data-toggle="m-tooltip"
                                    :data-original-title="titleNotPermisson"
                                    data-html="true"
                                  >
                                    <i class="m-nav__link-icon icon icon-export"></i>
                                    <span class="m-nav__link-text">Export giao dịch có sản phẩm</span>
                                  </a>
                                </li>
                              </ul>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                  <div class="s--list-count">
                    <div class="s-number-check">
                      với
                      <template v-if="dealChecked && dealChecked.length <= 0">tất cả</template>
                      ( {{ getQuantityItemChecked() }} giao dịch )
                    </div>
                  </div>
                </div>

                <div class="m-portlet__body-head-top-right" style="float: right;">
                  <div class="m--margin-right-0">
                    <div
                      m-dropdown-toggle="hover"
                      aria-expanded="true"
                      class="form-control nt-search-box-form-control m-input-icon m-input-icon--right search m-dropdown m-dropdown--inline m-dropdown--arrow m-dropdown--align-left m-dropdown--align-push"
                    >
                      <input
                        placeholder="Tìm kiếm"
                        type="text"
                        class="form-control form-control-sm m-input bg-transparent nt-table-search-box"
                        ref="dealSearch"
                        :value="searchText"
                        @keyup="dealSearch($event)"
                      />
                      <span
                        class="m-input-icon__icon m-input-icon__icon--right"
                        @click.prevent="dealSearchForClick()"
                      >
                        <span>
                          <i class="icon icon-search"></i>
                        </span>
                      </span>
                      <div class="m-dropdown__wrapper" style="z-index: 101;">
                        <span
                          class="m-dropdown__arrow m-dropdown__arrow--left m-dropdown__arrow--adjust"
                          style="right: auto; left: 100px;"
                        ></span>
                        <div class="m-dropdown__inner">
                          <div class="m-dropdown__body">
                            <div class="m-dropdown__content">
                              <span class="m--font-bolder">Bạn có thể tìm kiếm giao dịch theo:</span>
                              <p class="mb-0">• Mã giao dịch</p>
                              <p class="mb-0">• Số điện thoại</p>
                              <p class="mb-0">• Email</p>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                    <div class="search-note" v-if="isSearch">
                      <span>Tìm thấy {{ pagination.total_item }} giao dịch</span>
                    </div>
                    <div class="search-note" v-if="!isSearch">&nbsp;</div>
                  </div>
                </div>
              </div>
            </div>

            <div class="dataTables_wrapper">
              <div
                class="table-responsive nt-scroll-primary"
                id="table-responsive-data"
                v-if="deals && deals.length > 0"
              >
                <table class="table table-bordered table-hover nt-table-list nt-table-list-all">
                  <thead>
                    <tr>
                      <th class="id">
                        <label class="m-checkbox m-checkbox--primary m--margin-bottom-15">
                          <input
                            type="checkbox"
                            @click="checkedAllToggle()"
                            v-model="dealCheckAllPerPage[oldCurrentPage]"
                            value
                          />
                          <span></span>
                        </label>
                      </th>
                      <!--<th class="action">Tác vụ</th>-->

                      <template v-for="(attribute, index) in listAttributesForDeals">
                        <td
                          :key="index"
                          class="s--list-sort-attribute s--cursor-pointer"
                          :class="attribute.attribute_code"
                          v-if="attribute.is_default_attribute || attribute.external_attribute || !attribute.is_default_attribute && !attribute.is_hidden"
                        >
                          <div class="d-inline-block float-left">{{ attribute.attribute_name }}</div>
                        </td>
                      </template>
                    </tr>
                  </thead>

                  <tbody>
                    <tr v-for="(deal, indexA) in deals" :key="indexA">
                      <td class="id">
                        <label class="m-checkbox m-checkbox--primary m--margin-bottom-15">
                          <input
                            v-model="dealChecked"
                            type="checkbox"
                            @change="checkedDeal(deal)"
                            :value="deal"
                          />
                          <span></span>
                        </label>
                      </td>
                      <!--<td class="text-center action">
                                        <button aria-expanded="true" aria-haspopup="true" data-toggle="dropdown"
                                                class="btn m-btn m-btn--hover-primary m-btn--icon m-btn--icon-only m-btn--pill">
                                            <i class="la la-ellipsis-v"></i>
                                        </button>
                                        <div class="dropdown-menu">
                                            <a href=""
                                               class="dropdown-item">
                                                <i class="la la-edit"></i>
                                                Xem và Chỉnh sửa
                                            </a>
                                            <a href="#" data-target="#SubmitDeleteModal"
                                               data-toggle="modal"
                                               class="dropdown-item s--cursor-pointer">
                                                <i class="la la-trash"></i>
                                                Xóa tạm
                                            </a>
                                        </div>
                      </td>-->
                      <template v-for="(attribute, indexB) in listAttributesForDeals">
                        <td
                          :key="indexB"
                          :class="getClassForTableAttributes(attribute)"
                          v-if="attribute.is_default_attribute || attribute.external_attribute || !attribute.is_default_attribute && !attribute.is_hidden"
                        >
                          <template v-if="!attribute.external_attribute">
                            <div v-for="(attribute_value, indexC) in deal.attributes" :key="indexC">
                              <template v-if="deal.attributes">
                                <template v-if="attribute_value.attribute_id == attribute.id">
                                  <template
                                    v-if="!attribute_value.value || attribute_value.value == '' || attribute_value.value == null "
                                  >
                                    <template v-if="attribute.data_type_id == 7">0</template>
                                    <template v-else>
                                      <!-- - -->
                                    </template>
                                  </template>
                                  <template
                                    v-else-if="attribute.attribute_code == 'transaction_status'"
                                  >
                                    <span
                                      :class="renderElementClass(helpers.getAttributeOptions(attribute, attribute_value.value, 'option_value'))"
                                    >{{ helpers.getAttributeOptions(attribute, attribute_value.value, 'option_value') }}</span>
                                  </template>
                                  <template v-else-if="attribute.attribute_code == 'order_code'">
                                    <template
                                      v-if="accessible( userCheckAddOn, 'deal', PERMISSION_SHOW_DEAL, userCurrentPermissions)"
                                    >
                                      <a
                                        class="m-link m-link--primary nt-link"
                                        :href="getRouteLink('dealDetail', {deal_id: deal.id})"
                                      >{{ attribute_value.value }}</a>

                                      <!--<router-link class="m-link m-link&#45;&#45;primary nt-link" target="_blank"-->
                                      <!--:to="{name : 'dealDetail', params : {team_id : currentTeam.team_id, deal_id : deal.id} }">-->
                                      <!--{{ attribute_value.value }}-->
                                      <!--<i class="icon-external-link-01"></i>-->
                                      <!--</router-link>-->
                                    </template>
                                    <template v-else>
                                      <a
                                        class="m-link m-link--primary nt-link"
                                        href="javascript:;"
                                        data-toggle="m-tooltip"
                                        :data-original-title="titleNotPermisson"
                                        data-html="true"
                                      >{{ attribute_value.value }}</a>
                                    </template>
                                  </template>
                                  <template
                                    v-else-if="attribute.data_type_id == 2"
                                  >{{ attribute_value.value | formatDateTime }}</template>
                                  <template
                                    v-else-if="attribute.data_type_id == 3"
                                  >{{ attribute_value.value | formatDateTime(false) }}</template>
                                  <template
                                    v-else-if="attribute.data_type_id == 4"
                                  >{{ attribute_value.value | formatPhone }}</template>
                                  <template
                                    v-else-if="attribute.data_type_id == 6"
                                  >{{ convertNumber(attribute_value.value)}}</template>
                                  <template
                                    v-else-if="attribute.data_type_id == 7"
                                  >{{ parseFloat(attribute_value.value) | formatNumberPrice }}</template>
                                  <template v-else-if="attribute.data_type_id == 8">
                                    {{ helpers.getAttributeOptions(attribute, attribute_value.value,
                                    'option_value') }}
                                  </template>
                                  <template
                                    v-else-if="attribute.data_type_id == 9 && attribute.attribute_code !== 'contact_user'"
                                  >
                                    {{ helpers.getAttributeOptions(attribute, attribute_value.value,
                                    'option_value') }}
                                  </template>
                                  <template
                                    v-else-if="attribute.data_type_id == 9 && attribute.attribute_code === 'contact_user'"
                                  >
                                    <list-contact
                                      :customer_id="deal.customer_id"
                                      :is_dropdown="true"
                                      :contact_value="attribute_value.value"
                                    ></list-contact>
                                    <!--{{ helpers.getNameContact(contacts, attribute_value.value) }}-->
                                  </template>
                                  <template v-else-if="attribute.data_type_id == 10">
                                    <span
                                      style="margin-bottom: 3px; margin-right: 3px;"
                                      class="nt-barge-dropdown"
                                      v-for="(multi_value, value_index) in helpers.getAttributesOptions(attribute, attribute_value.value)"
                                      :key="value_index"
                                    >
                                      <template
                                        v-if="multi_value.option_value && multi_value.option_value.length > 0"
                                      >
                                        <template
                                          v-if="multi_value.option_value && multi_value.option_value.length > 14"
                                        >
                                          <span
                                            data-toggle="m-tooltip"
                                            data-placement="bottom"
                                            :data-original-title="multi_value.option_value"
                                          >{{ multi_value.option_value | truncateWords }}</span>
                                        </template>
                                        <template v-else>{{ multi_value.option_value }}</template>
                                      </template>
                                      <template v-else>{{multi_value.option_value}}</template>
                                    </span>
                                  </template>
                                  <template v-else-if="attribute.data_type_id == 11">
                                    <span
                                      style="margin-bottom: 3px; margin-right: 3px;"
                                      class="nt-barge-dropdown"
                                      v-for="(multi_value, value_index) in helpers.getAttributesOptions(attribute, attribute_value.value)"
                                      :key="value_index"
                                    >
                                      <template
                                        v-if="multi_value.option_value && multi_value.option_value.length > 0"
                                      >
                                        <template
                                          v-if="multi_value.option_value && multi_value.option_value.length > 14"
                                        >
                                          <span
                                            data-toggle="m-tooltip"
                                            data-placement="bottom"
                                            :data-original-title="multi_value.option_value"
                                          >{{ multi_value.option_value | truncateWords }}</span>
                                        </template>
                                        <template v-else>{{ multi_value.option_value }}</template>
                                      </template>
                                      <template v-else>{{multi_value.option_value}}</template>
                                    </span>
                                  </template>
                                  <template v-else-if="attribute.data_type_id === 12">
                                    <span
                                      v-if="attribute_value.value && attribute_value.value.length > 38"
                                      data-toggle="m-tooltip"
                                      data-placement="bottom"
                                      :data-original-title="attribute_value.value"
                                    >{{attribute_value.value | truncateWords }}</span>
                                    <span v-else>{{attribute_value.value}}</span>
                                  </template>
                                  <template v-else-if="attribute.data_type_id === 13">
                                    <span
                                      style="margin-bottom: 3px; margin-right: 3px;"
                                      class="nt-barge-dropdown"
                                      v-for="(multi_value, value_index) in helpers.getAttributesOptions(attribute, attribute_value.value)"
                                      :key="value_index"
                                    >
                                      <template
                                        v-if="multi_value.option_value && multi_value.option_value.length > 0"
                                      >
                                        <template
                                          v-if="multi_value.option_value && multi_value.option_value.length > 14"
                                        >
                                          <span
                                            data-toggle="m-tooltip"
                                            data-placement="bottom"
                                            :data-original-title="multi_value.option_value"
                                          >{{ multi_value.option_value | truncateWords }}</span>
                                        </template>
                                        <template v-else>{{ multi_value.option_value }}</template>
                                      </template>
                                      <template v-else>{{multi_value.option_value}}</template>
                                    </span>
                                  </template>
                                  <template v-else-if="attribute.data_type_id == 14">
                                    {{ helpers.getAttributeOptions(attribute, attribute_value.value,
                                    'option_value') }}
                                  </template>
                                  <template v-else-if="attribute.data_type_id == 15">
                                    <span class="nt-barge-dropdown mr-2 mb-2">
                                      <span
                                        v-for="(multi_value, indexD) in listUsers"
                                        :key="indexD"
                                      >
                                        <template v-if="multi_value.id === deal.user_id">
                                          <template
                                            v-if="multi_value.full_name && multi_value.full_name.length > 14"
                                          >
                                            <span
                                              data-toggle="m-tooltip"
                                              data-placement="bottom"
                                              :data-original-title="multi_value.full_name"
                                            >{{ multi_value.full_name | truncateWords }}</span>
                                          </template>
                                          <template v-else>{{ multi_value.full_name }}</template>
                                        </template>
                                      </span>
                                    </span>
                                  </template>
                                  <template v-else-if="attribute.data_type_id == 16">
                                    <span
                                      class="nt-barge-dropdown mr-2 mb-2"
                                      v-for="(multi_value, indexE) in helpers.getChargePersonValue(listUsers, attribute_value.value)"
                                      :key="indexE"
                                    >
                                      <template
                                        v-if="multi_value.full_name && multi_value.full_name.length > 0"
                                      >
                                        <template
                                          v-if="multi_value.full_name && multi_value.full_name.length > 14"
                                        >
                                          <span
                                            data-toggle="m-tooltip"
                                            data-placement="bottom"
                                            :data-original-title="multi_value.full_name"
                                          >{{ multi_value.full_name | truncateWords }}</span>
                                        </template>
                                        <template v-else>{{ multi_value.full_name }}</template>
                                      </template>
                                      <template v-else>{{multi_value.full_name}}</template>
                                    </span>
                                  </template>
                                  <template v-else>
                                    <template
                                      v-if="attribute_value.value && attribute_value.value.length > 0"
                                    >{{attribute_value.value | truncateWords }}</template>
                                    <template v-else>{{attribute_value.value}}</template>
                                  </template>
                                </template>
                              </template>
                            </div>
                          </template>
                          <template v-else>
                            <template
                              v-if="attribute.data_type.id == 'charge_person' && deal.assigners && deal.assigners.length > 0 && listUsers && listUsers.length > 0"
                            >
                              <template
                                v-for="(multi_value, indexF) in helpers.getChargePersonValue(listUsers, deal.assigners)"
                              >
                                <div
                                  style="margin-bottom: 3px; margin-right: 3px;"
                                  class="nt-barge-dropdown"
                                  :key="indexF"
                                >
                                  <!--<i class="la la-user" style="font-size: 13px;"></i>&nbsp;-->
                                  {{ multi_value.full_name | truncateWords }}
                                </div>
                              </template>
                            </template>
                            <template v-else-if="attribute.attribute_code == 'user_id'">
                              <template v-for="(multi_value, indexJ) in listUsers">
                                <div
                                  style="margin-bottom: 3px; margin-right: 3px;"
                                  class="nt-barge-dropdown"
                                  :key="indexJ"
                                  v-if="multi_value.id === deal.user_id"
                                >{{ multi_value.full_name | truncateWords }}</div>
                              </template>
                            </template>
                            <template
                              v-else-if="attribute.attribute_code == 'created_at'"
                            >{{ deal.created_at | formatDateTime(false) }}</template>
                            <template v-else>
                              <!-- - -->
                            </template>
                          </template>
                        </td>
                      </template>
                    </tr>
                  </tbody>
                </table>
              </div>
              <div v-if="deals && deals.length <= 0" class="s--not-found">
                <span>Chưa có giao dịch nào.</span>
              </div>
              <div
                v-else
                class="dataTables_paginate paging_simple_numbers m--margin-top-20 d-flex justify-content-end"
              >
                <pagination
                  :loader="isLoaderDeals"
                  :pagination="pagination"
                  @paginate="getPaginationDeal"
                ></pagination>
              </div>
            </div>
            <div
              v-if="loadDataDeals"
              style="position: absolute;left: 0px;top: 0px;width: 100%;height: 100%;background: #ffffff8a;z-index: 12;"
            >
              <div
                class="m-loader m-loader--brand m-loader--lg"
                style="width: 30px; height: 30px; display: inline-block; position:absolute; left:50%; top:50%; transform: translate(-50%, -50%);"
              ></div>
            </div>
          </div>
        </div>
        <Pipeline :filter="currentParams.filter" v-else />
      </div>
    </div>
    <import-deal @importDealSuccessfully="refresh"></import-deal>
  </div>
</template>
